import math

def calculate_scalar_product(vector_a,vector_b):
    #A vector is always a list
    scalar = 0
    #For each vector element multiply it with the element of the other vector
    for i in range(0,len(vector_a)):
        scalar = scalar + vector_a[i]*vector_b[i]
        #sum them all up to a single value
    return scalar


def calculate_vector_norm(vector_a):
    #A vector is always a list
    norm=0
    #Go through all vector elements
    for i in range(0,len(vector_a)):
        #For each element square it and add the result to the norm
        norm = norm+ vector_a[i]*vector_a[i]
    #The norm is the squareroot of the above sum
    norm = math.sqrt(norm)
    return norm


def calculate_angle_between_vectors(vector_a,vector_b):
    #A vector is always a list
    #Calculate all ingredients of the formula
    scalar = calculate_scalar_product(vector_a,vector_b)
    norm_a = calculate_vector_norm(vector_a)
    norm_b = calculate_vector_norm(vector_b)
    #Put the ingredients in a fraction
    fraction = scalar/(norm_a*norm_b)
    #Use cos-1 to retrieve the angle in radians
    angle = math.acos(fraction)
    return math.degrees(angle) #return the angle in degrees


def calculate_angles_via_trigonometry(opposite_kathete,hypothenuse):
    #kathete and hypothenuse are both scalar values
    #Use the Sine formula
    angle = math.asin(opposite_kathete/hypothenuse)
    return math.degrees(angle)
    